;; Problem 15
;; 19 April 2002

;; Starting in the top left corner of a 2x2 grid, there are 6 routes
;; (without backtracking) to the bottom right corner.
 
;; How many routes are there through a 20x20 grid?


;; If you rotate the box 45 deg. then it looks like a tree.  At each
;; point, you can take a left or go right.  Based on the size of the
;; box, you will have to take N lefts and N rights.  The enumerations
;; of these (shuffling) should be the number of possible paths through
;; the grid/tree.  For a grid of 1x2 there are 1L and 1R, once you
;; 'fix' one of the left or right's in its position, we have 2 choose
;; 1 (eg: L), for a 2x2 it there are 2Ls and 2 Rs, so we have 4
;; positions choose 2 (to fix the positions of the Ls), for a 3x3 we
;; have 3Ls and 3Rs, it is 6 choose 3.  For a 20x20 it is 40 positions
;; in which to choose 20 Ls.
;; 
;; 1x1
;;  LR
;;  RL
;; 2x2
;;  LLRR
;;  LRLR
;;  LRRL
;;  RLLR
;;  RLRL
;;  RLLR


(defun fact (num)
  (loop 
   for ii = num then (- ii 1)
   for total = (* 1 ii) then (* total ii)
   do
   (when (= 1 ii)
     (return total))))

'(loop for ii from 1 to 5
      do
      (format t "fact:~a => ~a~&"
	      ii
	      (fact ii)))

;(fact 40)

(defun n-choose-k (nn kk)
  (cond ((= nn kk)
	 (error "Can't compute n-choose-k of ~a ~a, will cause div by zero~&" nn kk))
	(t
	 (/
	  (fact nn)
	  (*
	   (fact kk)
	   (fact (- nn kk)))))))

(n-choose-k 40 20) ; 137846528820

